Index: drivers/net/open_eth.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/open_eth.c,v
retrieving revision 1.1
retrieving revision 1.14
diff -u -r1.1 -r1.14
--- drivers/net/open_eth.c	2 Jan 2006 18:36:38 -0000	1.1
+++ drivers/net/open_eth.c	16 Mar 2009 19:23:39 -0000	1.14
@@ -712,199 +676,158 @@
 			return -ENOMEM;
 	}
 
-	__clear_user(cep,sizeof(*cep));
+	__clear_user(cep, sizeof(*cep));
+
+	if (dev->base_addr == 0x0)
+		dev->base_addr = (unsigned long)__ioremap(ETH_BASE_ADD, OETH_TOTAL_SIZE, 0);
+	else
+		dev->base_addr = (unsigned long)__ioremap((unsigned long)dev->base_addr, OETH_TOTAL_SIZE, 0);
 
+    if(request_region(dev->base_addr, OETH_TOTAL_SIZE, cardname) == 0) {
+		printk("%s: unable to request region!\n", dev->name);
+        return -EAGAIN;
+    }
+		
 	/* Get pointer ethernet controller configuration registers.
 	 */
-	/*
-	cep->regs = (oeth_regs *)(OETH_REG_BASE);
-	regs = (oeth_regs *)(OETH_REG_BASE);
-	*/
-	cep->regs = (oeth_regs *)getmappedaddr(OETH_REG_BASE);
-	regs = (oeth_regs *)getmappedaddr(OETH_REG_BASE);
-	
+	cep->regs = (oeth_regs *)(dev->base_addr + OETH_REG_OFFSET);
+	regs = (oeth_regs *)(dev->base_addr + OETH_REG_OFFSET);
 	
 	/* Reset the controller.
 	 */
- 	write_reg(OETH_MODER_RST, regs->moder); /* Reset ON */
- 	write_reg(read_reg(regs->moder)&~OETH_MODER_RST, regs->moder);
-
-	/* Setting TXBD base to OETH_TXBD_NUM.
- 	write_reg(OETH_TXBD_NUM, regs->tx_bd_num);
+	regs->moder = OETH_MODER_RST;	/* Reset ON */
+	regs->moder &= ~OETH_MODER_RST;	/* Reset OFF */
+	
+ 	/* Setting TXBD base to OETH_TXBD_NUM.
+    */
+    regs->tx_bd_num = OETH_TXBD_NUM;
 	
 	/* Initialize TXBD pointer
-	 *////?w talvez endereco da RAM do FPGA
-	cep->tx_bd_base = (oeth_bd *)OETH_BD_BASE;
-	tx_bd = (volatile oeth_bd *)OETH_BD_BASE;
-
+	*/
+	cep->tx_bd_base = (oeth_bd *)(dev->base_addr + OETH_BD_OFFSET);
+	tx_bd =  (volatile oeth_bd *)(dev->base_addr + OETH_BD_OFFSET);
+	
 	/* Initialize RXBD pointer
-	 *////?w talvez endereco da RAM do FPGA
-	cep->rx_bd_base = ((oeth_bd *)OETH_BD_BASE) + OETH_TXBD_NUM;
-	rx_bd = ((volatile oeth_bd *)OETH_BD_BASE) + OETH_TXBD_NUM;
-
+	*/
+	cep->rx_bd_base = ((oeth_bd *)(dev->base_addr + OETH_BD_OFFSET)) + OETH_TXBD_NUM;
+	rx_bd =  ((volatile oeth_bd *)(dev->base_addr + OETH_BD_OFFSET)) + OETH_TXBD_NUM;
+	
 	/* Initialize transmit pointers.
 	 */
 	cep->rx_cur = 0;
-#ifdef CONFIG_OETH_UNKNOWN_TX_NEXT
-        /* the first time use value passed by bootloader
-         * __PHX__ fixme, this woun't work if you have this compiled as module
-         */
-        {
-                int tmp_next = *((int *)(0x00000000));
-
-                /* sanity check */
-                if ((tmp_next >= 0) && (tmp_next < OETH_TXBD_NUM))
-                        cep->tx_next = tmp_next;
-                else {
-                        printk(KERN_WARNING "open_eth: illegal number of TX buffer descriptors passed (%d), using default (if you did not use ethernet before starting linux this is ok)\n",
-                               tmp_next);
-                        cep->tx_next = 0;
-                }
-        }
-#else
-        /* or read it from eth register, or set it to 0 in eth */
-	cep->tx_next = 0;
-#endif
-	cep->tx_last = 0;
-	cep->tx_full = 0;
 
-	/* Set min/max packet length 
-	 *////?w perguntar pro jesse
- 	write_reg(0x00400600, regs->packet_len);
+	/* or read it from eth register, or set it to 0 in eth */
+	cep->tx_head = 0;
+	cep->tx_tail = 0;
+	cep->tx_goingfull = 0;
+	cep->tx_lock = 0;
+	cep->txq_stopped = 0;
+
+	/* Set min/max packet length
+	*/
+	regs->packet_len = 0x00400600;
 
 	/* Set IPGT register to recomended value 
 	 */
- 	write_reg(0x00000012, regs->ipgt);
+	regs->ipgt = 0x00000015;
 
 	/* Set IPGR1 register to recomended value 
 	 */
- 	write_reg(0x0000000c, regs->ipgr1);
+	regs->ipgr1 = 0x0000000c;
 
 	/* Set IPGR2 register to recomended value 
 	 */
- 	write_reg(0x00000012, regs->ipgr2);
+	regs->ipgr2 = 0x00000012;
 
 	/* Set COLLCONF register to recomended value 
 	 */
- 	write_reg(0x000f003f, regs->collconf);
-
+	regs->collconf = 0x000f003f;
+	
 	/* Set control module mode 
 	 */
 #if 0
- 	write_reg(OETH_CTRLMODER_TXFLOW | OETH_CTRLMODER_RXFLOW, regs->ctrlmoder);
+	regs->ctrlmoder = OETH_CTRLMODER_TXFLOW | OETH_CTRLMODER_RXFLOW;
 #else
- 	write_reg(0, regs->ctrlmoder);
+	regs->ctrlmoder = 0;
 #endif
 
-  /* Set PHY to show Tx status, Rx status and Link status *////?w
-  regs->miiaddress = 20<<8;
-  regs->miitx_data = 0x1422;
-  regs->miicommand = OETH_MIICOMMAND_WCTRLDATA;
-   
-  
-  ///?nao entendi como funciona isso
-  
-#ifdef TXBUFF_PREALLOC
+	/* Configure Micrel KS8721BL PHY
+	*/
+ 	cep->mii_if.dev = dev;
+	cep->mii_if.phy_id = MICREL_PHY;
+	cep->mii_if.phy_id_mask = OETH_MIIADDRESS_FIAD;
+	cep->mii_if.reg_num_mask = OETH_MIIADDRESS_RGAD;	
+	cep->mii_if.mdio_read = mdio_read;
+	cep->mii_if.mdio_write = mdio_write;
 
+	ks8721_reset(dev, cep->mii_if.phy_id);
+	ks8721_init(dev, cep->mii_if.phy_id);
+  
+	regs->miimoder = 0x164;
+	
 	/* Initialize TXBDs.
 	 */
-	for(i = 0, k = 0; i < OETH_TX_BUFF_PAGE_NUM; i++) {
-
-#ifndef SRAM_BUFF
-		mem_addr = __get_free_page(GFP_KERNEL);
-#endif
-
-		for(j = 0; j < OETH_TX_BUFF_PPGAE; j++, k++) {
-			tx_bd[k].len_status = OETH_TX_BD_PAD | OETH_TX_BD_CRC | OETH_RX_BD_IRQ;
-			tx_bd[k].addr = __pa(mem_addr);
-			mem_addr += OETH_TX_BUFF_SIZE;
-		}
-	}
-	tx_bd[OETH_TXBD_NUM - 1].len_status |= OETH_TX_BD_WRAP;
-#else
-
- 	/* Initialize TXBDs.
-	 */
+	mem_addr = OETH_BUF_OFFSET; 
 	for(i = 0; i < OETH_TXBD_NUM; i++) {
-
-		cep->tx_skbuff[i] = NULL;
-
-		tx_bd[i].len_status = (0 << 16) | OETH_TX_BD_PAD | OETH_TX_BD_CRC | OETH_RX_BD_IRQ;
-		tx_bd[i].addr = 0;
+		tx_bd[i].len_status = OETH_TX_BD_PAD | OETH_TX_BD_CRC | OETH_RX_BD_IRQ;
+		tx_bd[i].addr = mem_addr;
+		mem_addr += OETH_TX_BUFF_SIZE;
 	}
 	tx_bd[OETH_TXBD_NUM - 1].len_status |= OETH_TX_BD_WRAP;
-#endif
-
-#ifdef RXBUFF_PREALLOC
-
-	/* Initialize RXBDs.
-	 */
-	for(i = 0, k = 0; i < OETH_RX_BUFF_PAGE_NUM; i++) {
 
-#ifndef SRAM_BUFF
-		mem_addr = __get_free_page(GFP_KERNEL);
-#endif
 
-		for(j = 0; j < OETH_RX_BUFF_PPGAE; j++, k++) {
-			rx_bd[k].len_status = OETH_RX_BD_EMPTY | OETH_RX_BD_IRQ;
-			rx_bd[k].addr = __pa(mem_addr);
-			mem_addr += OETH_RX_BUFF_SIZE;
-		}
-	}
-	rx_bd[OETH_RXBD_NUM - 1].len_status |= OETH_RX_BD_WRAP;
-
-#else
 	/* Initialize RXBDs.
 	 */
+	mem_addr = OETH_BUF_OFFSET + (OETH_TX_BUFF_SIZE*OETH_TXBD_NUM); 
 	for(i = 0; i < OETH_RXBD_NUM; i++) {
-
-
-		rx_bd[i].len_status = (0 << 16) | OETH_RX_BD_IRQ;
-
-		cep->rx_skbuff[i] = NULL;
-
-		rx_bd[i].addr = 0;
+		rx_bd[i].len_status = OETH_RX_BD_EMPTY | OETH_RX_BD_IRQ;
+		rx_bd[i].addr = mem_addr;
+		mem_addr += OETH_RX_BUFF_SIZE;
 	}
 	rx_bd[OETH_RXBD_NUM - 1].len_status |= OETH_RX_BD_WRAP;
 
-#endif
 
-	/* Set default ethernet station address.
+	/* Set default ethernet station address to ep93xx eth addr + 1.
 	 */
-	dev->dev_addr[0] = MACADDR0;
-	dev->dev_addr[1] = MACADDR1;
-	dev->dev_addr[2] = MACADDR2;
-	dev->dev_addr[3] = MACADDR3;
-	dev->dev_addr[4] = MACADDR4;
-	dev->dev_addr[5] = MACADDR5;
-
- 	write_reg(MACADDR0 << 8 | MACADDR1, regs->mac_addr1);
- 	write_reg( MACADDR2 << 24 | MACADDR3 << 16 | MACADDR4 << 8 | MACADDR5, regs->mac_addr0);
+	{
+		unsigned char *epmac = (unsigned char *)IO_ADDRESS(MAC_INDAD);
+		unsigned long mac = epmac[5] | (epmac[4] << 8) | (epmac[3] << 16);
+
+		mac++;
+
+        	*(unsigned long *)IO_ADDRESS(MAC_AFP) = 0x00; 
+		dev->dev_addr[0] = epmac[0];
+		dev->dev_addr[1] = epmac[1];
+		dev->dev_addr[2] = epmac[2];
+		dev->dev_addr[3] = (mac >> 16) & 0xff;
+		dev->dev_addr[4] = (mac >> 8) & 0xff;
+		dev->dev_addr[5] = mac & 0xff;
+	}
+
+	regs->mac_addr1 = dev->dev_addr[0] << 8 | dev->dev_addr[1];
+	regs->mac_addr0 = dev->dev_addr[2] << 24 | dev->dev_addr[3] << 16 | 
+	  dev->dev_addr[4] << 8 | dev->dev_addr[5];
 	
 	/* Clear all pending interrupts 
 	 */
- 	write_reg(0xffffffff, regs->int_src);
+ 	regs->int_src = 0xffffffff;
 
 	/* Promisc, IFG, CRCEn
 	 */
- 	write_reg(read_reg(regs->moder) | OETH_MODER_PAD | OETH_MODER_IFG | OETH_MODER_CRCEN, regs->moder);
+	regs->moder |= OETH_MODER_PAD | OETH_MODER_IFG | OETH_MODER_CRCEN;
 
 	/* Enable interrupt sources.
 	 */
-	write_reg(OETH_INT_MASK_TXB 	| 
-			OETH_INT_MASK_TXE 	| 
+	regs->int_mask = OETH_INT_MASK_TXE 	| 
+			OETH_INT_MASK_TXB 	| 
+			OETH_INT_MASK_RXE 	| 
 			OETH_INT_MASK_RXF 	| 
-			OETH_INT_MASK_RXE 	|
-			OETH_INT_MASK_BUSY 	|
-			OETH_INT_MASK_TXC	|
-			OETH_INT_MASK_RXC, regs->int_mask);
+			OETH_INT_MASK_BUSY;
 
 	/* Fill in the fields of the device structure with ethernet values. 
 	 */
 	ether_setup(dev);
 
-	dev->base_addr = (unsigned long)OETH_REG_BASE;
-
 	/* The Open Ethernet specific entries in the device structure. 
 	 */
 	dev->open = oeth_open;
@@ -914,28 +837,61 @@
 	dev->set_multicast_list = oeth_set_multicast_list;
 	dev->set_mac_address = oeth_set_mac_add;
 
+	
+#if DEBUG
+	printk("%s: Open Ethernet Memory Map:\n", dev->name);
+	printk("\tRegister Base=0x%x \n\tTXBD=0x%x TXBUF=0x%x \n\tRXBD=0x%x RXBUF=0x%x\n", 
+		(uint)cep->regs, (uint)cep->tx_bd_base, tx_bd[0].addr, (uint)cep->rx_bd_base, rx_bd[0].addr);
+#endif
+		
 	printk("%s: Open Ethernet Core Version 1.0\n", dev->name);
 
 	return 0;
 }
 
 
-unsigned long getmappedaddr(unsigned long address)
-{
-	return TS7XXX_IO16_BASE + address;
-}
 
-void write_reg(unsigned long data, unsigned long address)
+#ifdef MODULE
+
+static struct net_device dev_openeth = { 
+	init: oeth_probe 
+	};
+	
+static int io = ETH_BASE_ADD;
+static int irq = IRQ_ETH_0;
+
+MODULE_PARM(io, "i");
+MODULE_PARM(irq, "i");
+
+MODULE_LICENSE("GPL");
+
+int init_module(void)
 {
-	outw((unsigned short)data>>16, &address);
-	outw((unsigned short)data, &address);
+	int result;
+
+	dev_openeth.base_addr = io;
+	dev_openeth.irq       = irq;
+	dev_openeth.init      = oeth_probe;
+
+	if ((result = register_netdev(&dev_openeth)) != 0)
+		return result;
+
+	return 0;
 }
 
-unsigned long read_reg(unsigned long address)
+void cleanup_module(void)
 {
-	unsigned long data;
-	data = inw(&address);
-	data = data<<16 | inw(&address);
-	return data;
+	free_irq(dev_openeth.irq, &dev_openeth);
+	release_region(dev_openeth.base_addr, OETH_TOTAL_SIZE);
+	
+	if (dev_openeth.priv)
+		kfree(dev_openeth.priv);
+
+	unregister_netdev(&dev_openeth);		
 }
 
+#endif /* MODULE */
+
+
+
+
Index: drivers/net/open_eth.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/open_eth.h,v
retrieving revision 1.1
retrieving revision 1.6
diff -u -r1.1 -r1.6
--- drivers/net/open_eth.h	2 Jan 2006 18:36:38 -0000	1.1
+++ drivers/net/open_eth.h	27 Mar 2006 18:22:45 -0000	1.6
@@ -1,14 +1,28 @@
-///? 
-//#define SRAM_BUFF	1
-//#define SRAM_BUFF_BASE	(FBMEM_BASE_ADD + 0x80000)
-#define IRQ_ETH_0 		0
-#define ETH_BASE_ADD 	0x0
-#define MACADDR0		0x0
-#define MACADDR1		0x0
-#define MACADDR2		0x0
-#define MACADDR3		0x0
-#define MACADDR4		0x0
-#define MACADDR5		0x0
+
+#ifndef _OPEN_ETH_H_
+#define _OPEN_ETH_H_
+
+#define MICREL_PHY				0x1
+
+#define IRQ_ETH_0 				40
+#define ETH_BASE_ADD 			0x72100000
+
+#define OETH_REG_OFFSET			0x2000								
+#define OETH_REG_BASE           (ETH_BASE_ADD + OETH_REG_OFFSET)
+#define OETH_REG_SIZE           0x400
+
+#define OETH_BD_OFFSET			0x2400								
+#define OETH_BD_BASE            (ETH_BASE_ADD + OETH_BD_OFFSET)	
+#define OETH_BD_SIZE			0x400
+
+#define OETH_BUF_OFFSET			0x0								
+#define OETH_BUF_BASE			(ETH_BASE_ADD + OETH_BUF_OFFSET)		
+#define OETH_BUF_SIZE	        0x2000								
+
+#define OETH_TOTAL_SIZE			(OETH_REG_SIZE + OETH_BD_SIZE + OETH_BUF_SIZE)
+
+#define OETH_TOTAL_BD           128
+#define OETH_MAXBUF_LEN         0x600
 
 /* Ethernet configuration registers */
 typedef struct _oeth_regs {
@@ -36,19 +50,10 @@
 
 /* Ethernet buffer descriptor */
 typedef struct _oeth_bd {
-#if 0
-        ushort  len;            /* Buffer length */
-        ushort  status;         /* Buffer status */
-#else
         uint    len_status;
-#endif
         uint    addr;           /* Buffer address */
 } oeth_bd;
 
-#define OETH_REG_BASE           ETH_BASE_ADD
-#define OETH_BD_BASE            (ETH_BASE_ADD + 0x400)
-#define OETH_TOTAL_BD           128
-#define OETH_MAXBUF_LEN         0x600
                                 
 /* Tx BD */                     
 #define OETH_TX_BD_READY        0x8000 /* Tx BD Ready */
@@ -92,6 +97,7 @@
                                 OETH_RX_BD_CRCERR               | \
                                 OETH_RX_BD_LATECOL)
 
+
 /* MODER Register */
 #define OETH_MODER_RXEN         0x00000001 /* Receive Enable  */
 #define OETH_MODER_TXEN         0x00000002 /* Transmit Enable */
@@ -133,7 +139,7 @@
 #define OETH_CTRLMODER_PASSALL  0x00000001 /* Pass Control Frames */
 #define OETH_CTRLMODER_RXFLOW   0x00000002 /* Receive Control Flow Enable */
 #define OETH_CTRLMODER_TXFLOW   0x00000004 /* Transmit Control Flow Enable */
-                               
+                           
 /* MII Mode Register */        
 #define OETH_MIIMODER_CLKDIV    0x000000FF /* Clock Divider */
 #define OETH_MIIMODER_NOPRE     0x00000100 /* No Preamble */
@@ -153,3 +159,5 @@
 #define OETH_MIISTATUS_BUSY     0x00000002 /* MII Busy */
 #define OETH_MIISTATUS_NVALID   0x00000004 /* Data in MII Status Register is invalid */
 
+#endif  /* _OPEN_ETH_H_ */
+
Index: drivers/net/pci-skeleton.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/net/pci-skeleton.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/net/pci-skeleton.c	22 Jul 2004 19:49:34 -0000	1.1
+++ drivers/net/pci-skeleton.c	4 Aug 2004 01:29:10 -0000	1.2
@@ -602,7 +602,7 @@
 	*ioaddr_out = NULL;
 	*dev_out = NULL;
 
-	/* dev zeroed in init_etherdev */
+	/* dev zeroed in alloc_etherdev */
 	dev = alloc_etherdev (sizeof (*tp));
 	if (dev == NULL) {
 		printk (KERN_ERR PFX "unable to alloc new ethernet\n");
@@ -789,7 +789,7 @@
 	dev->irq = pdev->irq;
 	dev->base_addr = (unsigned long) ioaddr;
 
-	/* dev->priv/tp zeroed and aligned in init_etherdev */
+	/* dev->priv/tp zeroed and aligned in alloc_etherdev */
 	tp = dev->priv;
 
 	/* note: tp->chipset set in netdrv_init_board */
